#!/usr/bin/env python
#License GPL
#amk.py
#Version 0.2.5
#Author Fabrizio Ruggeri
#Contact: fabrizio.ruggeri@gmail.com

from qt import *
import sys
import os
#from form import AmuleKform

class AmuleKform(QWidget):
    def __init__(self,parent = None,name = None,fl = 0):
        QWidget.__init__(self,parent,name,fl)

        if not name:
            self.setName("Form1")


        Form1Layout = QGridLayout(self,1,1,11,6,"Form1Layout")

        layout6 = QVBoxLayout(None,0,6,"layout6")

        self.textLabel1 = QLabel(self,"textLabel1")
        layout6.addWidget(self.textLabel1)

        self.listView1 = QListView(self,"listView1")
        self.listView1.addColumn(self.__tr("File Name"))
        self.listView1.addColumn(self.__tr("Ed2k Link"))
        layout6.addWidget(self.listView1)

        layout4 = QHBoxLayout(None,0,6,"layout4")

        self.sendButton = QPushButton(self,"sendButton")
        layout4.addWidget(self.sendButton)

        self.progressBar2 = QProgressBar(self,"progressBar2")
        self.progressBar2.setEnabled(0)
        layout4.addWidget(self.progressBar2)

        self.textLabel1_2 = QLabel(self,"textLabel1_2")
        self.textLabel1_2.setEnabled(0)
        layout4.addWidget(self.textLabel1_2)
        spacer6 = QSpacerItem(148,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        layout4.addItem(spacer6)

        self.exitButton = QPushButton(self,"exitButton")
        layout4.addWidget(self.exitButton)
        layout6.addLayout(layout4)

        layout5 = QHBoxLayout(None,0,6,"layout5")

        self.textLabel1_3 = QLabel(self,"textLabel1_3")
        layout5.addWidget(self.textLabel1_3)
        layout6.addLayout(layout5)

        Form1Layout.addLayout(layout6,0,0)

        self.languageChange()

        self.resize(QSize(605,471).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.exitButton,SIGNAL("clicked()"),self.close)


    def languageChange(self):
        self.setCaption(self.__tr("Form1"))
        self.textLabel1.setText(self.__tr("<b>Extracetd ed2k link<font size=\"+1\"></font></b>"))
        self.listView1.header().setLabel(0,self.__tr("File Name"))
        self.listView1.header().setLabel(1,self.__tr("Ed2k Link"))
        self.sendButton.setText(self.__tr("Send to &aMule"))
        self.sendButton.setAccel(QKeySequence(self.__tr("Alt+A")))
        self.textLabel1_2.setText(self.__tr("<b>Succesfully Sended</b>"))
        self.exitButton.setText(self.__tr("E&xit"))
        self.exitButton.setAccel(QKeySequence(self.__tr("Alt+X")))
        self.textLabel1_3.setText(self.__tr("<font size=\"-1\">Note: You must have aMule already launched to send links</font>"))


    def __tr(self,s,c = None):
        return qApp.translate("AmuleKform",s,c)

#Questa classe eredita il form creato col designer
class MyForm(AmuleKform):
	
	itemNumber = 0
	def __init__(self):
		AmuleKform.__init__(self)
		self.connect(self.sendButton,SIGNAL('clicked()'), self.sendToMule)
		#self.listView1.setSelectionMode(QListView.Multi)
		
	#Aggiungiamo un funzione per inserire elementi nel form che prende due stringhe
	
	def fillListView(self,nome,elink):
		item = QCheckListItem(self.listView1,"Selected",QCheckListItem.CheckBox)
		item.setText(0,nome+"  ")
		item.setText(1,elink)
		item.setOn(True)
		self.itemNumber = self.itemNumber + 1
		self.progressBar2.setTotalSteps(self.itemNumber)
		
	#Questa funzione legge da ogni riga la seconda colonna(il link) e lo invia ad aMule
	def sendToMule(self):
		self.progressBar2.setEnabled(1)
		itemList=QListViewItemIterator(self.listView1)
		i=0
		while (itemList.current()):
			i += 1
			if ( itemList.current().isOn() == True ):
				os.popen('ed2k \"'+itemList.current().text(1).__str__()+'\"')
			self.progressBar2.setProgress(i)
			itemList += 1
		self.textLabel1_2.setEnabled(1)
			
		
	


if __name__ == "__main__":
     app = QApplication(sys.argv)
     myf = MyForm()
     
     #questa parte legge il file generato dallo script amulecollection e estrae nome e link
     try:
	     f = open (os.path.expanduser('~')+"/.deleteMe")   #Apre il file creato dallo script
     except IOError:
	     os.popen('kdialog --error \"I can\'t read this collection file\\nCheck if it\'s corrupted\"')
	     quit()
     try:    #Estrae nome del file e link e le aggiunge al form come elementi
	     for link in f: 
		    name = link[link.find("ed2k://|file|")+13:link.find("|",link.find("ed2k://|file|")+13)]
		    myf.fillListView(name,link)
     finally:
			f.close()
			
     myf.show()
     app.setMainWidget(myf)
     app.exec_loop()